<?php

require_once("supportcenter.php");

class SUPPORTCENTER_CTRL_Support extends OW_ActionController {

	function myinit() {
		$language = OW::getLanguage();
		OW::getDocument()->addStyleSheet( OW::getPluginManager()->getPlugin("supportcenter")->getStaticCssUrl()."supportcenter.css" );
                OW::getDocument()->setTitle($language->text("supportcenter","support_title"));
                OW::getDocument()->setDescription($language->text("supportcenter","support_description"));
                OW::getDocument()->setHeading($language->text("supportcenter","support_heading"));
	}

	//forms
	function build_search_form() {
		$language = OW::getLanguage();

		$form=new Form("supportcenter_form_search");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$textField = new TextField("text");
		$textField->setLabel($language->text("supportcenter", "form_search"));
		$textField->setHasInvitation(true);
		$textField->setRequired();

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_add_tag_submit"));

		$form->addElement($textField);
		$form->addElement($submit);

		return $form;
	}
	function build_new_ticket_form() {
		$language=OW::getLanguage();

		$form=new Form("supportcenter_form_new_ticket");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$text_subject = new TextField("subject");
		$text_subject->setLabel($language->text("supportcenter", "form_new_ticket_subject"));
		$text_subject->setHasInvitation(true);
		$text_subject->setRequired();

		$buttons = array(
		    BOL_TextFormatService::WS_BTN_BOLD,
		    BOL_TextFormatService::WS_BTN_ITALIC,
		    BOL_TextFormatService::WS_BTN_UNDERLINE,
		    BOL_TextFormatService::WS_BTN_IMAGE,
		    BOL_TextFormatService::WS_BTN_LINK,
		    BOL_TextFormatService::WS_BTN_ORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_UNORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_MORE,
		    BOL_TextFormatService::WS_BTN_SWITCH_HTML,
		    BOL_TextFormatService::WS_BTN_HTML
		);
		$text_body = new WysiwygTextarea("text", $buttons);
		$text_body->setSize(WysiwygTextarea::SIZE_L);
		$text_body->setLabel($language->text("supportcenter", "form_new_ticket_text"));
		$text_body->setRequired();

		$category_query=SupportCenterDB::ticket_category_list();
		$categories=array();
		foreach($category_query as $data) {
			$categories[$data["id"]]=$data["text"];
		}

		$department_query=SupportCenterDB::department_list();
		$departments=array();
		foreach($department_query as $data) {
			$departments[$data["id"]]=$data["text"];
		}

		$cat = new Selectbox("category");
		$cat->setLabel($language->text("supportcenter", "form_new_ticket_category"));
		$cat->setInvitation("Select");
		$cat->setOptions($categories);
		$cat->setRequired(true);

		$dep = new Selectbox("department");
		$dep->setLabel($language->text("supportcenter", "form_new_ticket_department"));
		$dep->setInvitation("Select");
		$dep->setOptions($departments);
		$dep->setRequired();

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_new_ticket_submit"));

		$form->addElement($text_subject);
		$form->addElement($text_body);
		$form->addElement($cat);
		$form->addElement($dep);
		$form->addElement($submit);

		return $form;		
	}
	function build_ticket_reply_form() {
		$language=OW::getLanguage();

		$form=new Form("supportcenter_form_ticket_reply");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$buttons = array(
		    BOL_TextFormatService::WS_BTN_BOLD,
		    BOL_TextFormatService::WS_BTN_ITALIC,
		    BOL_TextFormatService::WS_BTN_UNDERLINE,
		    BOL_TextFormatService::WS_BTN_IMAGE,
		    BOL_TextFormatService::WS_BTN_LINK,
		    BOL_TextFormatService::WS_BTN_ORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_UNORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_MORE,
		    BOL_TextFormatService::WS_BTN_SWITCH_HTML,
		    BOL_TextFormatService::WS_BTN_HTML
		);
		$text_body = new WysiwygTextarea("text", $buttons);
		$text_body->setSize(WysiwygTextarea::SIZE_L);
		$text_body->setLabel($language->text("supportcenter", "form_ticket_reply_text"));
		$text_body->setRequired();

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_ticket_reply_submit"));

		$form->addElement($text_body);
		$form->addElement($submit);

		return $form;		
	}


	public function index() {
		$this->myinit();

		$form=$this->build_search_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			
		        //$this->redirect("/support/knowledgebase/search/".$values["text"]);
			$this->redirect(OW::getRouter()->urlForRoute("supportcenter-knowledgebase-search",array("text"=>$values["text"])));
		}

		$top_articles_query=SupportCenterDB::article_list_top();
		$top_articles=array();
		foreach($top_articles_query as $article) {
			array_push($top_articles,array(
				"title" => $article["title"],
				"rating" => round($article["rating"],2),
				"url_view" => OW::getRouter()->urlForRoute("supportcenter-knowledgebase-article",array("id"=>$article["id"]))
			));
		}

		$this->assign("top_articles_list",$top_articles);
		$this->assign("text_articles","Search Articles");
		$this->assign("top_articles","Top Articles");
		$this->assign("text_article_menu","Tickets");
		$this->assign("url_knowledgebase",OW::getRouter()->urlForRoute("supportcenter-knowledgebase"));
		$this->assign("url_ticket_my",OW::getRouter()->urlForRoute("supportcenter-tickets-my"));
		$this->assign("url_ticket_new",OW::getRouter()->urlForRoute("supportcenter-tickets-new"));
	}
	public function articleSearch($params) {
		$this->myinit();

		$article_data=SupportCenterDB::article_search($params["text"]);

		$articles=array();
		foreach($article_data as $a) {
			array_push($articles,array(
				"text"=>$a["title"],
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-knowledgebase-article",array("id"=>$a["id"]))
			));
		}
		$this->assign("items",$articles);
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-support"));
	}
	public function knowledgebase($params) {
		$this->myinit();

		$article_data=SupportCenterDB::article_list();
		$articles=array();

		foreach($article_data as $a) {
			array_push($articles,array(
				"text" => $a["title"],
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-knowledgebase-article",array("id"=>$a["id"]))
			));
		}

		$this->assign("items",$articles);
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-support"));
	}
	public function article($params) {
		$this->myinit();

		OW::getDocument()->addStyleSheet( OW::getPluginManager()->getPlugin("supportcenter")->getStaticCssUrl()."rating.css" );
		OW::getDocument()->addScript( OW::getPluginManager()->getPlugin("supportcenter")->getStaticJsUrl()."jquery.rating.js" );

		$aid=$params["id"];

		$art=SupportCenterDB::article_get($aid);
		$this->assign("article",$art);

		$rate_url=OW::getRouter()->urlForRoute("supportcenter-knowledgebase-article-rate",array("id"=>$aid));
		$rating_current=SupportCenterDB::article_rating_get($aid,OW::getUser()->getId());
		$rate_script="$('#rate').rating('$rate_url',{maxvalue:5,curvalue:$rating_current});";
		OW::getDocument()->addOnloadScript($rate_script);

		$tags=array();
		$atags=SupportCenterDB::article_get_tags($art);
		foreach($atags as $a) {
			array_push($tags,array("text" => $a["text"],"id" => $a["id"]));
		}

		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-knowledgebase"));
		$this->assign("tags",$tags);
	}
	public function articleTag($params) {
		$this->myinit();

		$articles=SupportCenterDB::article_list_by_tag($params["id"]);
		$art=array();
		foreach($articles as $a) {
			array_push($art,array(
				"text"=>$a["title"],
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-knowledgebase-article",array("id"=>$a["id"]))
			));
		}
		$this->assign("tag",SupportCenterDB::tag_get_by_id($params["id"])["text"]);
		$this->assign("items",$art);
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-support"));
	}
	public function articleRate($params) {
		SupportCenterDB::article_rating_set($params["id"],OW::getUser()->getId(),$_POST["rating"]);
	}

	//tickets
	public function ticketsMy() {
		$this->myinit();

		$tickets_q=SupportCenterDB::ticket_list_by_author(OW::getUser()->getId());
		$tickets=array();

		foreach($tickets_q as $data) {
			array_push($tickets,array(
				"text"=>$data["subject"],
				"requested_deletion"=>$data["requested_deletion"],
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-tickets-view",array("id"=>$data["id"])),
			));
		}

		$this->assign("items",$tickets);		
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-support"));
	}
	public function ticketsView($param) {
		$this->myinit();

		$form=$this->build_ticket_reply_form();
		$this->addForm($form);

		$ticket=SupportCenterDB::ticket_get($param["id"]);
		if($ticket["author_id"]!=OW::getUser()->getId()) {
		        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-tickets-my"));
			return;
		}
		$ticket["author"]=BOL_UserService::getInstance()->getDisplayName($ticket["author_id"]);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			SupportCenterDB::ticket_add_message(array(
				"ticket_id"=>$param["id"],
				"author_id"=>OW::getUser()->getId(),
				"text"=>$values["text"]
			),1);
			OW::getFeedback()->info("Message posted");


		        $userId = OW::getUser()->getId();
			$avatars = BOL_AvatarService::getInstance()->getAvatarsUrlList(array($userId));

			$notificationParams = array(
			    'pluginKey' => 'supportcenter',
			    'action' => 'ticketUpdated',
			    'entityType' => 'supportcenter-ticketUpdated',
			    //'entityId' => $target_user,
			    //'userId' => $target_user,
			    'time' => time()
			);
			$notificationData = array(
			    'string' => array(
				'key' => 'supportcenter+ticket_notification',
				'vars' => array(
				    'content' => $ticket["subject"]
				)
			    ),
			    'avatar' => OW::getPluginManager()->getPlugin("supportcenter")->getStaticUrl()."img/ic_reply.png",
				"url"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-view",array("id"=>$ticket["id"]))
			);

			$query_users=SupportCenterDB::department_get_users($ticket["department_id"]);
			$users=array();
			foreach($query_users as $u) {
				array_push($users,$u["user_id"]);
			}
			if(!in_array(1,$users)) {
				array_push($users,1);
			}
			foreach($users as $user) {
				$notificationParams["entityId"]=$user;
				$notificationParams["userId"]=$user;
				$event = new OW_Event('notifications.add',$notificationParams,$notificationData);
				OW::getEventManager()->trigger($event);
			}
		}

		$messages_q=SupportCenterDB::ticket_get_messages($ticket["id"]);
		$messages=array();
		foreach($messages_q as $data) {
			array_push($messages,array(
				"author"=>BOL_UserService::getInstance()->getDisplayName($data["author_id"]),
				"text"=>$data["text"],
				"created"=>$data["created"],
			));
		}

		$this->assign("ticket",$ticket);
		$this->assign("messages",$messages);
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-tickets-my"));
		$this->assign("url_deletion",OW::getRouter()->urlForRoute("supportcenter-tickets-delete",array("id"=>$ticket["id"])));
		$this->assign("url_cancel_deletion",OW::getRouter()->urlForRoute("supportcenter-tickets-delete-cancel",array("id"=>$ticket["id"])));
	}
	public function ticketsNew() {
		$this->myinit();

		$form=$this->build_new_ticket_form();
		$this->addForm($form);

		$url_back=OW::getRouter()->urlForRoute("supportcenter-tickets-my");

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();

			$ticket_id=SupportCenterDB::ticket_new(array(
				"author_id"=> OW::getUser()->getId(),
				"subject" => $values["subject"],
				"text" => $values["text"],
				"department_id" => $values["department"],
				"category_id" => $values["category"],
			));



		        $userId = OW::getUser()->getId();
			$avatars = BOL_AvatarService::getInstance()->getAvatarsUrlList(array($userId));

			$notificationParams = array(
			    'pluginKey' => 'supportcenter',
			    'action' => 'ticketUpdated',
			    'entityType' => 'supportcenter-ticketUpdated',
			    //'entityId' => $target_user,
			    //'userId' => $target_user,
			    'time' => time()
			);
			$notificationData = array(
			    'string' => array(
				'key' => 'supportcenter+ticket_notification_new',
				'vars' => array(
				    'content' => $values["subject"]
				)
			    ),
			    'avatar' => OW::getPluginManager()->getPlugin("supportcenter")->getStaticUrl()."img/ic_reply.png",
			    "url"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-view",array("id"=>$ticket_id))
			);

			$query_users=SupportCenterDB::department_get_users($values["department"]);
			$users=array();
			foreach($query_users as $u) {
				array_push($users,$u["user_id"]);
			}
			if(!in_array(1,$users)) {
				array_push($users,1);
			}
			foreach($users as $user) {
				$notificationParams["entityId"]=$user;
				$notificationParams["userId"]=$user;
				$event = new OW_Event('notifications.add',$notificationParams,$notificationData);
				OW::getEventManager()->trigger($event);
			}


		        $this->redirect($url_back);
			return;
		}
		$this->assign("url_cancel",$url_back);
	}
	public function ticketsDelete($params) {
		SupportCenterDB::ticket_set_request_deletion($params["id"],1);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-tickets-view",array("id"=>$params["id"])));
	}
	public function ticketsDeleteCancel($params) {
		SupportCenterDB::ticket_set_request_deletion($params["id"],0);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-tickets-view",array("id"=>$params["id"])));
	}
}


