<?php

$routes=[
	//id	url	func
	["support",			"support","index"],
	["knowledgebase",		"support/knowledgebase","knowledgebase"],
	["knowledgebase-article",	"support/knowledgebase/article/:id","article"],
	["knowledgebase-article-rate",	"support/knowledgebase/article/rate/:id","articleRate"],
	["knowledgebase-article-tag",	"support/knowledgebase/article/tag/:id","articleTag"],
	["knowledgebase-search",	"support/knowledgebase/search/:text","articleSearch"],
	["tickets-my",			"support/tickets/my","ticketsMy"],
	["tickets-view",		"support/tickets/view/:id","ticketsView"],
	["tickets-new",			"support/tickets/new","ticketsNew"],
	["tickets-delete",		"support/tickets/delete/:id","ticketsDelete"],
	["tickets-delete-cancel",	"support/tickets/delete_cancel/:id","ticketsDeleteCancel"],
];
$admin_routes=[
	["general",			"general","general"],
	["tags",			"tags","tags"],
	["tags-delete",			"tags/delete/:id","tagsDelete"],
	["tags-add",			"tags/add","tags_add"],

	["articles",			"articles","articles"],
	["articles-new",		"articles/new","articlesNew"],
	["articles-delete",		"articles/delete/:id","articlesDelete"],
	["articles-edit",		"articles/edit/:id","articlesEdit"],

	["ticket-categories",		"ticket_categories","ticketCategories"],
	["ticket-categories-delete",	"ticket_categories/delete/:id","ticketCategoriesDelete"],
	["tickets",			"tickets","tickets"],
	["tickets-view",		"tickets/view/:id","ticketsView"],
	["tickets-delete",		"tickets/delete/:id","ticketsDelete"],
	["departments",			"departments","departments"],
	["departments-view",		"departments/view/:id","departmentsView"],
	["departments-delete",		"departments/delete/:id","departmentsDelete"],
	["departments-user-delete",	"departments/user/delete/:dep_id/:user_id","departmentsUserDelete"],
];

foreach($routes as $val) {
	OW::getRouter()->addRoute(new OW_Route("supportcenter-".$val[0], $val[1], "SUPPORTCENTER_CTRL_Support", $val[2]));
}
foreach($admin_routes as $val) {
	OW::getRouter()->addRoute(new OW_Route("supportcenter-admin-".$val[0], "admin/supportcenter/".$val[1], "SUPPORTCENTER_CTRL_Admin", $val[2]));
}

function supportcenter_notify(BASE_CLASS_EventCollector $e) {
    $e->add(array(
        'section' => 'supportcenter',
        'action' => 'ticketUpdated',
        'description' => OW::getLanguage()->text('supportcenter', 'notification_ticket_updated'),
        'selected' => true,
        'sectionLabel' => OW::getLanguage()->text('supportcenter', 'notification_section_label'),
        'sectionIcon' => 'ow_ic_reply'
    ));

}
OW::getEventManager()->bind('notifications.collect_actions', 'supportcenter_notify');


